package net.sf.tomp.xml.include.xtcl;

import net.sf.tomp.xml.include.AdaptiveFilterImpl;
import net.sf.tomp.xml.type.TypeDatabase;
import net.sf.tomp.xml.type.xtcl.TypeDetectorFilterCommand;
import net.sf.tomp.xtcl.Context;

import java.io.PrintStream;

/**
 * DOCUMENT ME!
 * 
 * @author tomp
 */
public class AdaptiveFilterCommand extends TypeDetectorFilterCommand {
    /**
     * DOCUMENT ME!
     * 
     * @param context DOCUMENT ME!
     * @return DOCUMENT ME!
     * @throws Exception DOCUMENT ME!
     */
    public int execute(Context context) throws Exception {
        PrintStream out = context.getOut();

        if (out == null) {
            return 0;
        }

        AdaptiveFilterImpl af = new AdaptiveFilterImpl();
        TypeDatabase tdb = (TypeDatabase) context.get(tdVar);

        if (tdb == null) {
            out.print("ERR " + this);

            return 1;
        } else {
            af.setTypeDatabase(tdb);
            initFilter(af, context);
            context.put(var, af);
            out.print("OK " + this);

            return 0;
        }
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public String toString() {
        return "ADAPTIVEFILTER " + var + " type-database=" + tdVar + " ("
                + listMap(params) + ")";
    }
}

/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
