package net.sf.tomp.xml.type;

/**
 * DOCUMENT ME!
 * 
 * @author $author$
 * @version $Revision$
 */
public interface TypeDatabase {
    // types
    Type getTypeForRootElement(String ns, String localName);

    /**
     * DOCUMENT ME!
     * 
     * @param name DOCUMENT ME!
     * @param dtPublic DOCUMENT ME!
     * @param dtSystem DOCUMENT ME!
     * @return DOCUMENT ME!
     */
    Type getTypeForDoctype(String name, String dtPublic, String dtSystem);

    /**
     * DOCUMENT ME!
     * 
     * @param identification DOCUMENT ME!
     * @return DOCUMENT ME!
     */
    Type getType(String identification);

    // transformations
    //void addTransformation(Type source, Type target, TypeTransformation t);
    void addTransformation(Type source, Type target, Variant v,
            TypeTransformation t);

    //TypeTransformation getTransformation(Type source, Type target);
    TypeTransformation getTransformation(Type source, Type target, Variant v);

    /**
     * DOCUMENT ME!
     * 
     * @param source DOCUMENT ME!
     * @param target DOCUMENT ME!
     * @param variant DOCUMENT ME!
     * @return DOCUMENT ME!
     */
    java.util.List getTransformationSequence(Type source, Type target,
            Variant variant);

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    Transformations getTransformations();
}

/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
