package net.sf.tomp.xml.type;

import org.xml.sax.XMLFilter;

/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision$
 */
public interface TypeTransformation extends net.sf.tomp.general.Parametrized
{
    /** DOCUMENT ME! */
    public static final TypeTransformation IDENTITY = new TypeTransformation()
        {
            public XMLFilter newFilter()
            {
                return null;
            }

            public double getCosts()
            {
                return 0;
            }

            public boolean isIdentity()
            {
                return true;
            }

            public void setParameter(String k, Object v)
            {
            }
        };

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     * @throws TypeTransformationException DOCUMENT ME!
     */
    XMLFilter newFilter() throws TypeTransformationException;

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    double getCosts();

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    boolean isIdentity();
}


/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
